var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { useState } from 'react';
import { isDayBefore, isDayAfter, isSameDay } from '../utils';
export function useDateRange(initialStartDate, initialEndDate) {
    if (initialStartDate === void 0) { initialStartDate = new Date(); }
    var _a = useState(initialStartDate), startDate = _a[0], setStartDate = _a[1];
    var _b = useState(initialEndDate), endDate = _b[0], setEndDate = _b[1];
    var _c = useState(false), selectionActive = _c[0], setSelectionActive = _c[1];
    function handleDayClick(day) {
        if (startDate && selectionActive && !isDayBefore(day, startDate)) {
            setStartDate(startDate);
            setEndDate(day);
            setSelectionActive(false);
        }
        else {
            setStartDate(day);
            setEndDate(undefined);
            setSelectionActive(true);
        }
    }
    function handleDayHover(day) {
        if (selectionActive && startDate && !isDayBefore(day, startDate)) {
            setEndDate(day);
        }
    }
    function processMonth(month) {
        return month.map(function (week) {
            return week.map(function (day) {
                var isStart = startDate && isSameDay(day.date, startDate);
                var isEnd = Boolean(endDate && isSameDay(day.date, endDate));
                return __assign({}, day, { selected: isStart || isEnd, inRange: Boolean(startDate &&
                        isDayAfter(day.date, startDate) &&
                        endDate &&
                        isDayBefore(day.date, endDate)), isStart: isStart,
                    isEnd: isEnd });
            });
        });
    }
    return { handleDayClick: handleDayClick, handleDayHover: handleDayHover, startDate: startDate, endDate: endDate, processMonth: processMonth };
}
