"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var utils_1 = require("../utils");
/**
 * Primitive react component that can be used to make a datepicker.
 */
var CalendarMonth = /** @class */ (function (_super) {
    __extends(CalendarMonth, _super);
    function CalendarMonth() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.getDropdowns = function (props) {
            var minDate = props.minDate, maxDate = props.maxDate, month = props.month;
            var firstDay = utils_1.startOfMonth(month);
            var today = new Date();
            var minYear = minDate ? minDate.getFullYear() : today.getFullYear() - 50;
            var maxYear = maxDate ? maxDate.getFullYear() + 1 : today.getFullYear() + 5;
            var dropdownMonths = Array.from({ length: 12 }, function (_, i) { return ({
                disabled: Boolean((minDate && utils_1.isDayBefore(utils_1.setMonth(month, i), minDate)) ||
                    (maxDate && utils_1.isDayAfter(utils_1.setMonth(month, i), maxDate))),
                value: i,
                selected: firstDay.getMonth() === i
            }); });
            var dropdownYears = Array.from({ length: maxYear - minYear }, function (_, i) { return ({
                value: i + minYear,
                disabled: false,
                selected: i + minYear === firstDay.getFullYear()
            }); });
            return [dropdownMonths, dropdownYears];
        };
        return _this;
    }
    CalendarMonth.prototype.getDaysofMonth = function (props) {
        var month = props.month, startDate = props.startDate, endDate = props.endDate, minDate = props.minDate, maxDate = props.maxDate;
        var currentMonth = utils_1.getDaysOfMonth(month);
        var startDateDisabled = !!startDate && !!minDate && !utils_1.isDayAfter(startDate, minDate);
        return currentMonth.map(function (week) {
            return week.map(function (day) {
                var date = day.date, inCurrentMonth = day.inCurrentMonth;
                var disabled = !inCurrentMonth ||
                    Boolean((minDate && utils_1.isDayBefore(date, minDate)) ||
                        (maxDate && utils_1.isDayAfter(date, maxDate)));
                var selected = !disabled &&
                    Boolean((startDate && utils_1.isSameDay(date, startDate)) ||
                        (endDate && utils_1.isSameDay(date, endDate)));
                var inRange = Boolean(startDate &&
                    utils_1.isDayAfter(date, startDate) &&
                    endDate &&
                    utils_1.isDayBefore(date, endDate));
                return {
                    date: date,
                    inRange: inCurrentMonth &&
                        !startDateDisabled &&
                        !disabled &&
                        (selected || inRange),
                    selected: selected,
                    disabled: disabled,
                    inCurrentMonth: inCurrentMonth
                };
            });
        });
    };
    CalendarMonth.prototype.render = function () {
        var _a;
        var _b = this.props, month = _b.month, render = _b.render, showDropdowns = _b.showDropdowns;
        var monthsDropdown;
        var yearsDropdown;
        if (showDropdowns) {
            _a = this.getDropdowns(this.props), monthsDropdown = _a[0], yearsDropdown = _a[1];
        }
        return render({
            days: this.getDaysofMonth(this.props),
            month: utils_1.startOfMonth(month),
            monthsDropdown: monthsDropdown,
            yearsDropdown: yearsDropdown
        });
    };
    return CalendarMonth;
}(React.Component));
exports.CalendarMonth = CalendarMonth;
